xmltooling::OpenSSLCredential Class Referenceabstract

An OpenSSL-specific credential. More...

`#include <xmltooling/security/OpenSSLCredential.h>`

Inheritance diagram for xmltooling::OpenSSLCredential:
[legend]
Collaboration diagram for xmltooling::OpenSSLCredential:
[legend]

## Public Member Functions

virtual void | attach (SSL_CTX *ctx) const =0
| Attaches credential to an OpenSSL SSL context object.
Public Member Functions inherited from xmltooling::X509Credential
virtual const std::vector< XSECCryptoX509 * > & | getEntityCertificateChain () const =0
| Gets an immutable collection of certificates in the entity's trust chain.
virtual const std::vector< XSECCryptoX509CRL * > & | getCRLs () const =0
| Gets an immutable collection of all CRLs associated with the credential.
virtual const char * | getSubjectName () const =0
| Gets the subject name of the first certificate in the chain.
virtual const char * | getIssuerName () const =0
| Gets the issuer name of the first certificate in the chain.
virtual const char * | getSerialNumber () const =0
| Gets the serial number of the first certificate in the chain.
virtual void | extract ()=0
| Extracts properties like issuer and subject from the first certificate in the chain.
Public Member Functions inherited from xmltooling::Credential
virtual unsigned int | getUsage () const =0
| Get credential usage types.
virtual const char * | getAlgorithm () const =0
| Returns an algorithm identifier for the Credential.
virtual unsigned int | getKeySize () const =0
| Returns the size of the key in bits.
virtual const XSECCryptoKey * | getPrivateKey () const =0
| Returns a secret or private key to use for signing or decryption operations.
virtual const XSECCryptoKey * | getPublicKey () const =0
| Returns a secret or public key to use for verification or encryption operations.
virtual const std::set< std::string > & | getKeyNames () const =0
| Returns names representing the Credential.
virtual xmlsignature::KeyInfo * | getKeyInfo (bool compact=false) const =0
| Returns a ds:KeyInfo object representing the Credential for use in communicating with other entities.
virtual const CredentialContext * | getCredentialContext () const
| Get the credential context information, which provides additional information specific to the context in which the credential was resolved.

## Additional Inherited Members

Public Types inherited from xmltooling::X509Credential
enum | ResolveTypes { RESOLVE_CERTS = 4 , RESOLVE_CRLS = 8 }
| Bitmask constants for limiting resolution process inside a CredentialResolver.
enum | KeyInfoTypes { KEYINFO_X509_CERTIFICATE = 4 , KEYINFO_X509_SUBJECTNAME = 8 , KEYINFO_X509_ISSUERSERIAL = 16 , KEYINFO_X509_DIGEST = 32 }
| Bitmask of supported KeyInfo content to generate.
Public Types inherited from xmltooling::Credential
enum | ResolveTypes { RESOLVE_KEYS = 1 , RESOLVE_NAMES = 2 }
| Bitmask constants for limiting resolution process inside a CredentialResolver.
enum | UsageTypes { UNSPECIFIED_CREDENTIAL = 0 , SIGNING_CREDENTIAL = 1 , TLS_CREDENTIAL = 2 , ENCRYPTION_CREDENTIAL = 4 }
| Bitmask of use cases for credentials.
enum | KeyInfoTypes { KEYINFO_KEY_VALUE = 1 , KEYINFO_KEY_NAME = 2 }
| Bitmask of supported KeyInfo content to generate.

## Detailed Description

An OpenSSL-specific credential.

## Member Function Documentation

## attach()

virtual void xmltooling::OpenSSLCredential::attach | ( | SSL_CTX * | ctx | ) | const

pure virtual

Attaches credential to an OpenSSL SSL context object.

The credential MUST be disposable after attachment.

Parameters

  ctx | an SSL context

The documentation for this class was generated from the following file:

- xmltooling/security/OpenSSLCredential.h